/*
 * Created on 03.12.2003 18:44:34
 * 
 * Multimediale Algorithmen und Datenstrukturen Assessments
 */
package mauda.plugin.fibheap;

/**
 * Interface for the base-operations on Fibonacci-Heaps.
 * 
 * @author Markus Krebs
 */
public interface FibHeapOperations {
	/**
	 * INSERT
	 * @param k key to insert
	 */
	public void insertOp(int k);
	/**
	 * DELETE_MIN
	 * @return key of removed node
	 */
	public int deleteminOp();
	/**
	 * DECREASE_KEY
	 * @param key key to decreased
	 * @param k new value of the decreased node
	 */
	public void decreasekeyOp(int key, int k);
	/**
	 * DELETE
	 * @param key key to delete
	 * @return deleted key
	 */
	public int deleteOp(int key);
}
